//
//  FolderView.m
//  Auto-Layout
//
//  Created by Clemens Wagner on 29.08.15.
//  Copyright © 2015 Clemens Wagner. All rights reserved.
//

#import "FolderView.h"

@implementation FolderView

- (instancetype)init {
    self = [super init];
    if (self) {
        self.translatesAutoresizingMaskIntoConstraints = NO;
        self.backgroundColor = [UIColor clearColor];
    }
    return self;
}

- (UIEdgeInsets)alignmentRectInsets {
    return UIEdgeInsetsMake(2.0 * self.cornerRadius + self.badgeRadius, 0.0, 0.0, self.badgeRadius);
}

- (void)drawRect:(CGRect)inRect {
    CGFloat theRadius = self.cornerRadius;
    UIEdgeInsets theInsets = [self alignmentRectInsets];
    CGRect theBounds = self.bounds;
    CGRect theInnerRect = UIEdgeInsetsInsetRect(theBounds, theInsets);
    CGRect theInnerBounds = CGRectInset(theInnerRect, theRadius, theRadius);
    UIBezierPath *thePath = [UIBezierPath bezierPath];
    
    [self.tintColor setFill];
    [thePath moveToPoint:CGPointMake(CGRectGetMinX(theInnerRect), CGRectGetMinY(theInnerBounds))];
    [thePath addArcWithCenter:theInnerBounds.origin radius:theRadius startAngle:-M_PI endAngle:-M_PI / 2.0 clockwise:YES];
    [thePath addLineToPoint:CGPointMake(CGRectGetMidX(theInnerBounds), CGRectGetMinY(theInnerRect))];
    [thePath addLineToPoint:CGPointMake(CGRectGetMidX(theInnerRect), CGRectGetMinY(theInnerRect) - theRadius)];
    [thePath addArcWithCenter:CGPointMake(CGRectGetMidX(theInnerRect) + theRadius, CGRectGetMinY(theInnerRect) - theRadius) radius:theRadius startAngle:-M_PI endAngle:-M_PI / 2.0 clockwise:YES];
    [thePath addLineToPoint:CGPointMake(CGRectGetMaxX(theInnerBounds), CGRectGetMinY(theInnerRect) - 2.0 * theRadius)];
    
    [thePath addArcWithCenter:CGPointMake(CGRectGetMaxX(theInnerBounds), CGRectGetMinY(theInnerRect) - theRadius) radius:theRadius startAngle:M_PI / 2.0 endAngle:0.0 clockwise:YES];
    [thePath addLineToPoint:CGPointMake(CGRectGetMaxX(theInnerRect), CGRectGetMinY(theInnerBounds))];
    [thePath addArcWithCenter:CGPointMake(CGRectGetMaxX(theInnerBounds), CGRectGetMaxY(theInnerBounds)) radius:theRadius startAngle:0.0 endAngle:M_PI / 2.0 clockwise:YES];
    [thePath addLineToPoint:CGPointMake(CGRectGetMinX(theInnerBounds), CGRectGetMaxY(theInnerRect))];
    [thePath addArcWithCenter:CGPointMake(CGRectGetMinX(theInnerBounds), CGRectGetMaxY(theInnerBounds)) radius:theRadius startAngle:-M_PI / 2.0 endAngle:-M_PI clockwise:YES];
    [thePath closePath];
    [thePath fill];
}

@end
